Bug 889261 - Review Request: globus-gram-job-manager-lsf - Globus Toolkit - LSF Job Manager Support
Summary: Review Request: globus-gram-job-manager-lsf - Globus Toolkit - LSF Job Manage...
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Björn 'besser82' Esser
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-12-20 16:13 UTC by Mattias Ellert
Modified: 2013-08-06 17:16 UTC (History)
3 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2013-08-02 03:27:29 UTC
besser82: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Mattias Ellert 2012-12-20 16:13:31 UTC
Spec URL: http://www.grid.tsl.uu.se/review/globus-gram-job-manager-lsf.spec
SRPM URL: http://www.grid.tsl.uu.se/review/globus-gram-job-manager-lsf-1.1-1.fc17.src.rpm

Description:
The Globus Toolkit is an open source software toolkit used for building Grid
systems and applications. It is being developed by the Globus Alliance and
many others all over the world. A growing number of projects and companies are
using the Globus Toolkit to unlock the potential of grids for their cause.

The globus-gram-job-manager-lsf package contains:
LSF Job Manager Support

This is a new package in Globus Toolkit 5.2.3 that reintroduces the support for LSF, replacing the obsolete globus-gram-job-manager-setup-lsf package

Fedora Account System Username: ellert

Comment 2 Björn 'besser82' Esser 2013-05-31 12:40:44 UTC
configure-script throws some warnings during build:

checking for mpiexec... no
checking for mpirun... configure: WARNING: Cannot locate mpiexec
no
configure: WARNING: Cannot locate mpirun
configure: WARNING: Using default lsf profile of /etc/profile.lsf
checking for bsub... configure: WARNING: Unable to read lsf.profile, manual configuration needed
no
checking for bqueues... configure: WARNING: Cannot locate bsub
no
checking for bjobs... configure: WARNING: Cannot locate bqueues
no
checking for bkill... configure: WARNING: Cannot locate bjobs
no
checking for bhist... configure: WARNING: Cannot locate bkill
no
checking for bacct... configure: WARNING: Cannot locate bhist
no
configure: WARNING: Cannot locate bacct

rpmlint complains:

Rpmlint
-------
Checking: globus-gram-job-manager-lsf-1.1-2.fc20.x86_64.rpm
          globus-gram-job-manager-lsf-setup-poll-1.1-2.fc20.noarch.rpm
          globus-gram-job-manager-lsf-setup-seg-1.1-2.fc20.x86_64.rpm
globus-gram-job-manager-lsf.x86_64: W: obsolete-not-provided globus-gram-job-manager-setup-lsf-doc
globus-gram-job-manager-lsf.x86_64: E: no-binary
globus-gram-job-manager-lsf-setup-poll.noarch: W: no-documentation
globus-gram-job-manager-lsf-setup-seg.x86_64: W: no-documentation
globus-gram-job-manager-lsf-setup-seg.x86_64: E: zero-length /etc/globus/scheduler-event-generator/available/lsf
3 packages and 0 specfiles checked; 2 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint globus-gram-job-manager-lsf globus-gram-job-manager-lsf-s 
etup-poll globus-gram-job-manager-lsf-setup-seg
globus-gram-job-manager-lsf.x86_64: W: obsolete-not-provided globus-gram-job-manager-setup-lsf-doc
globus-gram-job-manager-lsf.x86_64: E: no-binary
globus-gram-job-manager-lsf-setup-poll.noarch: W: no-documentation
globus-gram-job-manager-lsf-setup-seg.x86_64: W: no-documentation
globus-gram-job-manager-lsf-setup-seg.x86_64: E: zero-length /etc/globus/scheduler-event-generator/available/lsf
3 packages and 0 specfiles checked; 2 errors, 3 warnings.

Does globus-gram-job-manager-lsf really need to be arched? It contains no arched binaries...

Comment 3 Mattias Ellert 2013-06-13 11:00:25 UTC
That the LSF client tools are not found during the build is not fatal.

The only implication of this is that the paths to these tools are not preconfigured in the installed configuration file. These can be added by the sysadmin after installation. If left unconfigured, $PATH will be searched for them at runtime.

globus-gram-job-manager-lsf should be noarch, but it can not be. If one of the subpackages built from a source rpm is arched, the main package can not be noarch. This is a known deficiency of rpm. (A noarch tag in the main package would apply to all sub-packages built form the srpm.)

Comment 4 Björn 'besser82' Esser 2013-06-13 11:23:08 UTC
Package has some issues.

#####

Package Review
==============

Legend:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package does not contain any libtool archives (.la)
  Note: globus-gram-job-manager-lsf-setup-seg :
  /usr/lib64/libglobus_seg_lsf.la
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries

  ---> please remove this at the end of %install.

- Arched BuildRequires in spec:
  BuildRequires:	globus-core%{?_isa} >= 8
  BuildRequires:	globus-gram-protocol-devel%{?_isa} >= 11
  BuildRequires:	globus-scheduler-event-generator-devel%{?_isa} >= 4
  BuildRequires:	globus-common-devel%{?_isa} >= 14
  BuildRequires:	globus-xio-devel%{?_isa} >= 3
  BuildRequires should not be arched.

  ---> Please fix.

- zero-length /etc/globus/scheduler-event-generator/available/lsf

  ---> consider packaging this file %ghost and touching it in %post


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: ldconfig called in %post and %postun if required.
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[-]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required

     ---> el5

[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in globus-
     gram-job-manager-lsf-setup-poll

     ---> subpkg is noarch

[x]: Package complies to the Packaging Guidelines
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated". 3 files have unknown license.
     Detailed output of licensecheck in
     /home/bjoern.esser/fedora/review/889261-globus-gram-job-manager-
     lsf/licensecheck.txt

     ---> License-Tag is fine.

[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

Perl:
[x]: Package contains the mandatory BuildRequires and Requires:.

     ---> pulled through other BRs

===== SHOULD items =====

Generic:
[-]: Buildroot is not present
     Note: Buildroot: present but not needed

     ---> el5

[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[-]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)

     ---> el5

[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: globus-gram-job-manager-lsf-1.1-2.fc20.x86_64.rpm
          globus-gram-job-manager-lsf-setup-poll-1.1-2.fc20.noarch.rpm
          globus-gram-job-manager-lsf-setup-seg-1.1-2.fc20.x86_64.rpm
globus-gram-job-manager-lsf.x86_64: W: obsolete-not-provided globus-gram-job-manager-setup-lsf-doc
globus-gram-job-manager-lsf.x86_64: E: no-binary
globus-gram-job-manager-lsf-setup-poll.noarch: W: no-documentation
globus-gram-job-manager-lsf-setup-seg.x86_64: W: no-documentation
globus-gram-job-manager-lsf-setup-seg.x86_64: E: zero-length /etc/globus/scheduler-event-generator/available/lsf
3 packages and 0 specfiles checked; 2 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint globus-gram-job-manager-lsf globus-gram-job-manager-lsf-s 
etup-poll globus-gram-job-manager-lsf-setup-seg
globus-gram-job-manager-lsf.x86_64: W: obsolete-not-provided globus-gram-job-manager-setup-lsf-doc
globus-gram-job-manager-lsf.x86_64: E: no-binary
globus-gram-job-manager-lsf-setup-poll.noarch: W: no-documentation
globus-gram-job-manager-lsf-setup-seg.x86_64: W: no-documentation
globus-gram-job-manager-lsf-setup-seg.x86_64: E: zero-length /etc/globus/scheduler-event-generator/available/lsf
3 packages and 0 specfiles checked; 2 errors, 3 warnings.
# echo 'rpmlint-done:'


Requires
--------
globus-gram-job-manager-lsf (rpmlib, GLIBC filtered):
    config(globus-gram-job-manager-lsf)
    globus-common-progs
    globus-gass-cache-program
    globus-gatekeeper
    globus-gram-job-manager
    globus-gram-job-manager-lsf-setup
    globus-gram-job-manager-scripts
    perl(:MODULE_COMPAT_5.16.3)
    perl(Config)
    perl(Globus::Core::Config)
    perl(Globus::Core::Paths)
    perl(Globus::GRAM::Error)
    perl(Globus::GRAM::JobManager)
    perl(Globus::GRAM::JobState)
    perl(IPC::Open3)

globus-gram-job-manager-lsf-setup-poll (rpmlib, GLIBC filtered):
    /bin/sh
    config(globus-gram-job-manager-lsf-setup-poll)
    globus-gram-job-manager-lsf
    globus-gram-job-manager-scripts

globus-gram-job-manager-lsf-setup-seg (rpmlib, GLIBC filtered):
    /bin/sh
    /sbin/ldconfig
    config(globus-gram-job-manager-lsf-setup-seg)
    globus-common(x86-64)
    globus-gram-job-manager-lsf(x86-64)
    globus-gram-job-manager-scripts
    globus-scheduler-event-generator(x86-64)
    globus-scheduler-event-generator-progs
    initscripts
    libc.so.6()(64bit)
    libglobus_common.so.0()(64bit)
    libglobus_common.so.0(GLOBUS_COMMON_14)(64bit)
    libglobus_scheduler_event_generator.so.0()(64bit)
    libpthread.so.0()(64bit)
    rtld(GNU_HASH)



Provides
--------
globus-gram-job-manager-lsf:
    config(globus-gram-job-manager-lsf)
    globus-gram-job-manager-lsf
    globus-gram-job-manager-lsf(x86-64)
    globus-gram-job-manager-setup-lsf
    perl(Globus::GRAM::JobManager::lsf)

globus-gram-job-manager-lsf-setup-poll:
    config(globus-gram-job-manager-lsf-setup-poll)
    globus-gram-job-manager-lsf-setup
    globus-gram-job-manager-lsf-setup-poll

globus-gram-job-manager-lsf-setup-seg:
    config(globus-gram-job-manager-lsf-setup-seg)
    globus-gram-job-manager-lsf-setup
    globus-gram-job-manager-lsf-setup-seg
    globus-gram-job-manager-lsf-setup-seg(x86-64)
    libglobus_seg_lsf.so.1()(64bit)



Source checksums
----------------
http://www.globus.org/ftppub/gt5/5.2/5.2.3/packages/src/globus_gram_job_manager_lsf-1.1.tar.gz :
  CHECKSUM(SHA256) this package     : 6f4026909496d2e4b0e29ae7881d5ee5486f392423aed17933809dfafb865127
  CHECKSUM(SHA256) upstream package : 6f4026909496d2e4b0e29ae7881d5ee5486f392423aed17933809dfafb865127


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 889261

#####

Please fix the issues and I'll grant review.

Comment 5 Björn 'besser82' Esser 2013-06-13 11:25:56 UTC
my bad (missed to mark it passed):

[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated". 3 files have unknown license.
     Detailed output of licensecheck in
     /home/bjoern.esser/fedora/review/889261-globus-gram-job-manager-
     lsf/licensecheck.txt

     ---> License-Tag is fine.

Comment 6 Björn 'besser82' Esser 2013-06-13 13:35:44 UTC
> - Package does not contain any libtool archives (.la)
>   Note: globus-gram-job-manager-lsf-setup-seg :
>   /usr/lib64/libglobus_seg_lsf.la
>   See: http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries
> 
>   ---> please remove this at the end of %install.

As discussed in bz #889262 there's an exception in the guidelines for globus-plugins allowing (the urgently needed) .la-files.

So this is no issue anymore.

Just fix arched-BRs and zero-length-file issue will be enough to get this granted.

Comment 7 Mattias Ellert 2013-06-13 13:50:00 UTC
I do not understand your comment about that the BRs should not be arched. For arched packages having arched BRs is preferred. Having these BRs from a different architecture is not sufficient for the package to build.

Comment 8 Björn 'besser82' Esser 2013-06-13 13:59:21 UTC
(In reply to Mattias Ellert from comment #7)
> I do not understand your comment about that the BRs should not be arched.
> For arched packages having arched BRs is preferred. Having these BRs from a
> different architecture is not sufficient for the package to build.

As far as my sponsor taught me:
BRs must not be arched, because they will become the Requires of the srpm and may cause the srpm not to build (created on x86_64 and build on i686) or may pull the wrong arch during build on multi-arch (created on i686 and build on x86_64). On Koji this won't be an issue, but...

Having arched-Requires is prefered, afaik.

Comment 9 Mattias Ellert 2013-06-13 14:36:15 UTC
This does not make sense. I have never had any problem caused by having %{?_isa} in BuildRequires, and I have had many problems caused by not having them. I strongly disagree with you on this.

Especially for multiarch, having %{?_isa} is essential for getting the build dependencies right - without it, it is completely broken in this case. If you are building on x86-64 and have a BR on e.g. zlib-devel, this BR can be satisfied by zlib-devel(x86-32), and nothing will complain if zlib-devel(x86-64) is not installed if you try to build.

I have never seen any problem in koji with it.

It is true that these will get recorded in the Requries of the srpm, but this is a tiny insignificant glitch that does not cause any problems, while leaving them out can cause a huge amount of problems.

Comment 10 Simone Caronni 2013-06-13 15:32:38 UTC
Hello,

(In reply to Mattias Ellert from comment #9)
> This does not make sense. I have never had any problem caused by having
> %{?_isa} in BuildRequires, and I have had many problems caused by not having
> them. I strongly disagree with you on this.

this has been discussed over and over in reviews with different opinions but in the end they should not be applied to -devel packages.

Look what happens if I download a src.rpm from Koji with _isa'ed BuildRequires:

$ rpm -qpR libguac-client-vnc-0.6.0-4.fc17.src.rpm 
cairo-devel(x86-64)  
gnutls-devel(x86-64)  
libguac-devel(x86-64) = 0.6.0
libvncserver-devel(x86-64)  
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(CompressedFileNames) <= 3.0.4-1

This means I cannot rebuild the src.rpm if I'm on an i686? This is wrong.

Please see this bug, from comment #39 onwards where Michael Schwendt explains it more clearly:

https://bugzilla.redhat.com/show_bug.cgi?id=820544

Regards,
--Simone

Comment 11 Björn 'besser82' Esser 2013-06-13 18:57:19 UTC
Regarding to [1] using arched-BRs are not allowed according to guidelines.  So take them out, please.

[1] https://lists.fedoraproject.org/pipermail/packaging/2013-June/009215.html

Comment 12 Mattias Ellert 2013-07-19 04:55:00 UTC
Hi again

Sorry for the delay. I found this new guideline about banning isa from BR so extremely stupid that I thought I would make an attempt to have it revoked before deliberately crippling the spec file. Unfortunately FPC is not very responsive and my ticket just sits there without any action taken.

Anyway, this is a battle I will have to have with FPC and not with you, so here is a new version of the package complying to the new guideline:

Spec URL: http://www.grid.tsl.uu.se/review/globus-gram-job-manager-lsf.spec
SRPM URL: http://www.grid.tsl.uu.se/review/globus-gram-job-manager-lsf-1.1-3.fc19.src.rpm

Comment 13 Björn 'besser82' Esser 2013-07-19 09:15:20 UTC
Package is fine, but one non-blocker:

  * globus-gram-job-manager-lsf-setup-seg.x86_64: E: zero-length
    /etc/globus/scheduler-event-generator/available/lsf

    ---> fix this by echo "." >> $file at the end of %install

You can fix this in SCM, then.

This one is finally

APPROVED!

Comment 14 Mattias Ellert 2013-07-19 21:10:44 UTC
Thank you for the review.

New Package SCM Request
=======================
Package Name: globus-gram-job-manager-lsf
Short Description: Globus Toolkit - LSF Job Manager Support
Owners: ellert
Branches: f18 f19 el5 el6
InitialCC:

Comment 15 Gwyn Ciesla 2013-07-22 09:53:14 UTC
Git done (by process-git-requests).

Comment 16 Fedora Update System 2013-07-22 13:03:44 UTC
globus-gridmap-verify-myproxy-callout-1.0-4.el5,globus-gram-job-manager-lsf-1.1-3.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/globus-gridmap-verify-myproxy-callout-1.0-4.el5,globus-gram-job-manager-lsf-1.1-3.el5

Comment 17 Fedora Update System 2013-07-22 13:04:01 UTC
globus-gridmap-verify-myproxy-callout-1.0-4.fc19,globus-gram-job-manager-lsf-1.1-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/globus-gridmap-verify-myproxy-callout-1.0-4.fc19,globus-gram-job-manager-lsf-1.1-3.fc19

Comment 18 Fedora Update System 2013-07-22 13:04:18 UTC
globus-gridmap-verify-myproxy-callout-1.0-4.el6,globus-gram-job-manager-lsf-1.1-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/globus-gridmap-verify-myproxy-callout-1.0-4.el6,globus-gram-job-manager-lsf-1.1-3.el6

Comment 19 Fedora Update System 2013-07-22 13:04:37 UTC
globus-gridmap-verify-myproxy-callout-1.0-4.fc18,globus-gram-job-manager-lsf-1.1-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/globus-gridmap-verify-myproxy-callout-1.0-4.fc18,globus-gram-job-manager-lsf-1.1-3.fc18

Comment 20 Fedora Update System 2013-07-22 21:46:01 UTC
globus-gridmap-verify-myproxy-callout-1.0-4.el6, globus-gram-job-manager-lsf-1.1-3.el6 has been pushed to the Fedora EPEL 6 testing repository.

Comment 21 Fedora Update System 2013-08-02 03:27:29 UTC
globus-gridmap-verify-myproxy-callout-1.0-4.fc18, globus-gram-job-manager-lsf-1.1-3.fc18 has been pushed to the Fedora 18 stable repository.

Comment 22 Fedora Update System 2013-08-02 03:29:04 UTC
globus-gridmap-verify-myproxy-callout-1.0-4.fc19, globus-gram-job-manager-lsf-1.1-3.fc19 has been pushed to the Fedora 19 stable repository.

Comment 23 Fedora Update System 2013-08-06 17:15:49 UTC
globus-gridmap-verify-myproxy-callout-1.0-4.el5, globus-gram-job-manager-lsf-1.1-3.el5 has been pushed to the Fedora EPEL 5 stable repository.

Comment 24 Fedora Update System 2013-08-06 17:16:20 UTC
globus-gridmap-verify-myproxy-callout-1.0-4.el6, globus-gram-job-manager-lsf-1.1-3.el6 has been pushed to the Fedora EPEL 6 stable repository.


Note You need to log in before you can comment on or make changes to this bug.